Index: gli/branches/rtl-gli/src/org/greenstone/gatherer/cdm/CollectionConfiguration.java
===================================================================
--- gli/branches/rtl-gli/src/org/greenstone/gatherer/cdm/CollectionConfiguration.java	(revision 18351)
+++ gli/branches/rtl-gli/src/org/greenstone/gatherer/cdm/CollectionConfiguration.java	(revision 18352)
@@ -293,5 +293,6 @@
                 value = tokenizer.nextToken ();
                 // Test if the value is actually a name, and if so add the name by itself, then put value into name so that it is parsed correctly during the next loop.
-                if(value.startsWith (StaticStrings.MINUS_CHARACTER)) {
+		// The value is not a name if it contains a space character: it's a quoted value
+                if (value.startsWith(StaticStrings.MINUS_CHARACTER) && value.indexOf(StaticStrings.SPACE_CHARACTER) == -1) {
                     arguments.put (name, null);
                     name = value;
@@ -439,11 +440,11 @@
         int option_elements_length = option_elements.getLength ();
         for(int j = 0; j < option_elements_length; j++) {
-            Element option_element = (Element) option_elements.item (j);
+	  Element option_element = (Element) option_elements.item (j);
             if(option_element.getAttribute (StaticStrings.ASSIGNED_ATTRIBUTE).equals (StaticStrings.TRUE_STR)) {
-                text.append (StaticStrings.SPACE_CHARACTER);
-                text.append (StaticStrings.MINUS_CHARACTER);
-                text.append (option_element.getAttribute (StaticStrings.NAME_ATTRIBUTE));
-                String value_str = XMLTools.getValue (option_element);
-                
+	      text.append (StaticStrings.SPACE_CHARACTER);
+	      text.append (StaticStrings.MINUS_CHARACTER);
+	      text.append (option_element.getAttribute (StaticStrings.NAME_ATTRIBUTE));
+	      String value_str = XMLTools.getValue (option_element);
+              
                 // Convert metadata element names to internal names, and remove extracted metadata namespaces
                 if (value_str.length () > 0) {
@@ -1330,4 +1331,5 @@
                 // The next token is the type
                 String type = tokenizer.nextToken ();
+		type = ensureNewPluginName(type);
                 command_element.setAttribute (StaticStrings.TYPE_ATTRIBUTE, type);
                 // Now we parse out the remaining arguments into a hashmapping from name to value
@@ -1372,4 +1374,10 @@
         }
         catch(Exception exception) {
+	    // This catch clause had been left empty.  If this is deliberate then
+	    // we should have a comment here explaining why there is no need to
+	    // print anything out.  Am assuming this is mistake for now, and
+	    // have added in a call to printStackTrace()
+	    System.err.println("Malformed plugin statement");
+	    exception.printStackTrace();
         }
         return command_element;
@@ -1420,18 +1428,20 @@
                     command_element.setAttribute (StaticStrings.TYPE_ATTRIBUTE, StaticStrings.INCLUDE_STR);
                 }
-                StringTokenizer pattern_tokenizer = new StringTokenizer (full_pattern_str, StaticStrings.SEPARATOR_CHARACTER);
-                if(pattern_tokenizer.countTokens () >= 2) {
-                    String content_str = pattern_tokenizer.nextToken ();
+
+                // Let's make sure it is a valid Greenstone configuration line
+                String[] results = full_pattern_str.split("\\" + StaticStrings.SEPARATOR_CHARACTER, 3);
+
+                if (results.length >= 2) {
+                    String content_str = results[0];
                     // Since the contents of indexes have to be certain keywords, or metadata elements, if the content isn't a keyword and doesn't yet have a namespace, append the extracted metadata namespace.
-                    if(!content_str.equals (StaticStrings.FILENAME_STR) && content_str.indexOf (StaticStrings.NS_SEP) == -1) {
+                    if (!content_str.equals (StaticStrings.FILENAME_STR) && content_str.indexOf (StaticStrings.NS_SEP) == -1) {
                         content_str = StaticStrings.EXTRACTED_NAMESPACE + content_str;
                     }
                     command_element.setAttribute (StaticStrings.CONTENT_ATTRIBUTE, content_str);
-                    XMLTools.setValue (command_element, pattern_tokenizer.nextToken ());
-                    if(pattern_tokenizer.hasMoreTokens ()) {
-                        command_element.setAttribute (StaticStrings.OPTIONS_ATTRIBUTE, pattern_tokenizer.nextToken ());
-                    }
-                }
-                pattern_tokenizer = null;
+                    XMLTools.setValue (command_element, results[1]);
+                    if (results.length >= 3) {
+                        command_element.setAttribute (StaticStrings.OPTIONS_ATTRIBUTE, results[2]);
+                    }
+                }
             }
         }
@@ -1521,43 +1531,68 @@
     
     static private String pluginToString (Element command_element, boolean show_extracted_namespace) {
-        StringBuffer text = new StringBuffer ();
-        if(!command_element.getAttribute (StaticStrings.SEPARATOR_ATTRIBUTE).equals (StaticStrings.TRUE_STR)) {
-            text.append (StaticStrings.PLUGIN_STR);
-            text.append (StaticStrings.TAB_CHARACTER);
-            text.append (StaticStrings.TAB_CHARACTER);
-            text.append (command_element.getAttribute (StaticStrings.TYPE_ATTRIBUTE));
-            // Retrieve, and output, the arguments
-            NodeList option_elements = command_element.getElementsByTagName (StaticStrings.OPTION_ELEMENT);
-            int option_elements_length = option_elements.getLength ();
-            if(option_elements_length > 0) {
-                for(int j = 0; j < option_elements_length; j++) {
-                    Element option_element = (Element) option_elements.item (j);
-                    if(option_element.getAttribute (StaticStrings.ASSIGNED_ATTRIBUTE).equals (StaticStrings.TRUE_STR)) {
-                        text.append (StaticStrings.SPACE_CHARACTER);
-                        text.append (StaticStrings.MINUS_CHARACTER);
-                        text.append (option_element.getAttribute (StaticStrings.NAME_ATTRIBUTE));
-                        String value_str = XMLTools.getValue (option_element);
-                        if(!show_extracted_namespace && value_str.startsWith (StaticStrings.EXTRACTED_NAMESPACE)) {
-                            value_str = value_str.substring (StaticStrings.EXTRACTED_NAMESPACE.length ());
-                        }
-                        if(value_str.length () > 0) {
-                            text.append (StaticStrings.SPACE_CHARACTER);
-                            if(value_str.indexOf (StaticStrings.SPACE_CHARACTER) == -1) {
-                                text.append (value_str);
-                            }
-                            else {
-                                text.append (StaticStrings.SPEECH_CHARACTER);
-                                text.append (value_str);
-                                text.append (StaticStrings.SPEECH_CHARACTER);
-                            }
-                        }
-                        value_str = null;
-                    }
-                    option_element = null;
-                }
-            }
-            option_elements = null;
-        }
-        return text.toString ();
+        if(command_element.getAttribute (StaticStrings.SEPARATOR_ATTRIBUTE).equals (StaticStrings.TRUE_STR)) { 
+	  return "";
+	}
+        StringBuffer text = new StringBuffer (StaticStrings.PLUGIN_STR);
+	text.append (StaticStrings.TAB_CHARACTER);
+	text.append (command_element.getAttribute (StaticStrings.TYPE_ATTRIBUTE));
+	// Retrieve, and output, the arguments
+	NodeList option_elements = command_element.getElementsByTagName (StaticStrings.OPTION_ELEMENT);
+	int option_elements_length = option_elements.getLength ();
+	if(option_elements_length > 0) {
+	  for(int j = 0; j < option_elements_length; j++) {
+	    Element option_element = (Element) option_elements.item (j);
+	    if(option_element.getAttribute (StaticStrings.ASSIGNED_ATTRIBUTE).equals (StaticStrings.TRUE_STR)) {
+	      text.append (StaticStrings.SPACE_CHARACTER);
+	      text.append (StaticStrings.MINUS_CHARACTER);
+	      text.append (option_element.getAttribute (StaticStrings.NAME_ATTRIBUTE));
+	      String value_str = XMLTools.getValue (option_element);
+
+	      
+	      // Convert metadata element names to internal names, and remove extracted metadata namespaces
+	      if (value_str.length () > 0) {
+		StringTokenizer string_tokenizer = new StringTokenizer (value_str, ",");
+		StringBuffer value_buffer = new StringBuffer ();
+		while (string_tokenizer.hasMoreElements ()) {
+		  String raw_token = (String) string_tokenizer.nextElement ();
+		  String token = raw_token.trim ();
+		  MetadataElement metadata_element = MetadataTools.getMetadataElementWithDisplayName (token);
+		  if (metadata_element != null) {
+		    token = metadata_element.getFullName ();
+		  }
+                        
+		  if (token.startsWith (StaticStrings.EXTRACTED_NAMESPACE)) {
+		    token = token.substring (StaticStrings.EXTRACTED_NAMESPACE.length ());
+		  }
+		  value_buffer.append (token);
+		  if (string_tokenizer.hasMoreElements ()) {
+		    value_buffer.append (",");
+		  }
+		}
+		value_str = value_buffer.toString ();
+	      }
+
+	      // if(!show_extracted_namespace && value_str.startsWith (StaticStrings.EXTRACTED_NAMESPACE)) {
+	      //            value_str = value_str.substring (StaticStrings.EXTRACTED_NAMESPACE.length ());
+	      //        }
+	      if(value_str.length () > 0) {
+		text.append (StaticStrings.SPACE_CHARACTER);
+		if(value_str.indexOf (StaticStrings.SPACE_CHARACTER) == -1) {
+		  text.append (value_str);
+		}
+		else {
+		  text.append (StaticStrings.SPEECH_CHARACTER);
+		  text.append (value_str);
+		  text.append (StaticStrings.SPEECH_CHARACTER);
+		}
+	      }
+	      value_str = null;
+	    }
+	    option_element = null;
+	  }
+	}
+	option_elements = null;
+	
+	return text.toString ();
     }
     
@@ -1719,5 +1754,4 @@
             e.setAttribute (StaticStrings.LANGUAGE_ATTRIBUTE, lang);
             XMLTools.setNodeText (e, text);
-            
             display_item_list.add (e);
         }
@@ -1873,5 +1907,5 @@
             Element e = (Element)index_children.item (i);
             String index_str = e.getAttribute (StaticStrings.NAME_ATTRIBUTE);
-            String index_str_display = index_str;//for creating collectionmetadata for this index
+            String index_str_display = index_str;//for creating collectionmetadata for this index 
             
             // Handling 'index' element
@@ -2047,4 +2081,5 @@
             Element e = (Element)plugin_children.item (i);
             String str = e.getAttribute (StaticStrings.NAME_ATTRIBUTE);
+	    str = ensureNewPluginName(str);
             Element plugin_element = to.createElement (StaticStrings.PLUGIN_ELEMENT);
             plugin_element.setAttribute (StaticStrings.TYPE_ATTRIBUTE, str);
@@ -2197,6 +2232,6 @@
             }
             if (format != null) {
-                String gsf_text = XMLTools.xmlNodeToStringWithoutNewline(format);
-                
+                String gsf_text = XMLTools.xmlNodeToStringWithoutIndenting(format);
+               
                 if (gsf_text.startsWith("<") && (gsf_text.indexOf("<") != gsf_text.lastIndexOf("<"))) {
                     gsf_text = gsf_text.substring(gsf_text.indexOf("<gsf"),
@@ -3090,11 +3125,4 @@
             StaticStrings.NAME_ATTRIBUTE, index_value);
             
-            if (collectionmetadata_list == null) {
-                //try adding the "." prefix
-                index_value = StaticStrings.DOT_CHARACTER + index_value;
-                collectionmetadata_list = XMLTools.getNamedElementList (source,
-                StaticStrings.COLLECTIONMETADATA_ELEMENT,
-                StaticStrings.NAME_ATTRIBUTE, index_value);
-            }
             if (collectionmetadata_list != null) {
                 
@@ -3149,11 +3177,4 @@
             StaticStrings.NAME_ATTRIBUTE, name_str);
             
-            if (collectionmetadata_list == null) {
-                //try adding the "." prefix
-                name_str = StaticStrings.DOT_CHARACTER + name_str;
-                collectionmetadata_list = XMLTools.getNamedElementList (source,
-                StaticStrings.COLLECTIONMETADATA_ELEMENT,
-                StaticStrings.NAME_ATTRIBUTE, name_str);
-            }
             if (collectionmetadata_list != null) {
                 
@@ -3291,27 +3312,15 @@
             StaticStrings.NAME_ATTRIBUTE, temp_str);
             
-            if (collectionmetadata_list == null) {
-                //try adding the "." prefix
-                String with_dot_str = StaticStrings.DOT_CHARACTER + temp_str;
-                collectionmetadata_list = XMLTools.getNamedElementList (source,
-                StaticStrings.COLLECTIONMETADATA_ELEMENT,
-                StaticStrings.NAME_ATTRIBUTE, with_dot_str);
-                
-                if (collectionmetadata_list == null) {
-                    //try the full name, i.e. with 'ex.'
-                    if (mg_indexer == true) {
-                        full_index_name = level_str+StaticStrings.COLON_CHARACTER+full_index_name;
-                    }
-                    collectionmetadata_list = XMLTools.getNamedElementList (source,
-                    StaticStrings.COLLECTIONMETADATA_ELEMENT,
-                    StaticStrings.NAME_ATTRIBUTE, full_index_name);
-                }
-                if (collectionmetadata_list == null) {
-                    with_dot_str = StaticStrings.DOT_CHARACTER + full_index_name;
-                    collectionmetadata_list = XMLTools.getNamedElementList (source,
-                    StaticStrings.COLLECTIONMETADATA_ELEMENT,
-                    StaticStrings.NAME_ATTRIBUTE, with_dot_str);
-                }
-            }
+	    if (collectionmetadata_list == null) {
+	      //try the full name, i.e. with 'ex.'
+	      if (mg_indexer == true) {
+		// but first append level info if we are mg
+		full_index_name = level_str+StaticStrings.COLON_CHARACTER+full_index_name;
+	      }
+	      collectionmetadata_list = XMLTools.getNamedElementList (source,
+			     StaticStrings.COLLECTIONMETADATA_ELEMENT,
+			     StaticStrings.NAME_ATTRIBUTE, full_index_name);
+	    }
+	
             if (collectionmetadata_list != null) {
                 
@@ -3368,11 +3377,4 @@
             StaticStrings.NAME_ATTRIBUTE, name_str);
             
-            if (collectionmetadata_list == null) {
-                //try adding the "." prefix
-                name_str = StaticStrings.DOT_CHARACTER + name_str;
-                collectionmetadata_list = XMLTools.getNamedElementList (source,
-                StaticStrings.COLLECTIONMETADATA_ELEMENT,
-                StaticStrings.NAME_ATTRIBUTE, name_str);
-            }
             if (collectionmetadata_list != null) {
                 
@@ -3732,5 +3734,5 @@
         // If we're using a remote Greenstone server, upload the new 'collectionConfig.xml' file
         if (Gatherer.isGsdlRemote) {
-            RemoteGreenstoneServer.uploadCollectionFile (collection_name, collect_cfg_file);
+            Gatherer.remoteGreenstoneServer.uploadCollectionFile (collection_name, collect_cfg_file);
         }
         
@@ -3824,5 +3826,5 @@
             // If we're using a remote Greenstone server, upload the new collect.cfg file
             if (Gatherer.isGsdlRemote) {
-                RemoteGreenstoneServer.uploadCollectionFile (collection_name, collect_cfg_file);
+                Gatherer.remoteGreenstoneServer.uploadCollectionFile (collection_name, collect_cfg_file);
             }
         }
@@ -3886,4 +3888,38 @@
         return skeleton;
     }
+
+  static private HashMap plugin_map = null;
+  
+  private void setUpPluginNameMap() {
+    plugin_map = new HashMap();
+    plugin_map.put("GAPlug", "GreenstoneXMLPlugin");
+    plugin_map.put("RecPlug", "DirectoryPlugin");
+    plugin_map.put("ArcPlug","ArchivesInfPlugin");
+    plugin_map.put("TEXTPlug","TextPlugin");
+    plugin_map.put("XMLPlug","ReadXMLFile");
+    plugin_map.put("EMAILPlug","EmailPlugin");
+    plugin_map.put("SRCPlug","SourceCodePlugin");
+    plugin_map.put("NULPlug","NulPlugin");
+    plugin_map.put("W3ImgPlug","HTMLImagePlugin");
+    plugin_map.put("PagedImgPlug","PagedImagePlugin");
+    plugin_map.put("METSPlug", "GreenstoneMETSPlugin");
+    plugin_map.put("DBPlug", "DatabasePlugin");
+    plugin_map.put("PPTPlug", "PowerPointPlugin");
+    plugin_map.put("PSPlug", "PostScriptPlugin");
+  }
+
+  private String ensureNewPluginName(String plugin) {
+    if (plugin.endsWith("Plugin")) return plugin;
+    if (plugin_map == null) {
+      setUpPluginNameMap();
+    }
+    String new_name = (String)plugin_map.get(plugin);
+    if (new_name != null) return new_name;
+    new_name = plugin.replaceAll("Plug", "Plugin");
+    return new_name;
+  }
+   
+
     ///*********************************************************************************************************///
 }
+
Index: gli/branches/rtl-gli/src/org/greenstone/gatherer/cdm/CollectionDesignManager.java
===================================================================
--- gli/branches/rtl-gli/src/org/greenstone/gatherer/cdm/CollectionDesignManager.java	(revision 18351)
+++ gli/branches/rtl-gli/src/org/greenstone/gatherer/cdm/CollectionDesignManager.java	(revision 18352)
@@ -78,4 +78,6 @@
     /** The text translation manager. */
     static public TranslationView translation_manager;
+    /** A manager of configuring depositor metadata */ 
+    static public DepositorMetadataManager depositormetadata_manager;
     /** These mark what needs to happen when building a collection where ONLY design options have been changed.
         The build requirements of the higher numbers must include doing everything from the lower numbers. */
@@ -128,4 +130,5 @@
 	supercollection_manager = new SuperCollectionManager(collect_config.getSuperCollection());
 	searchmetadata_manager = new SearchMetadataManager();
+	depositormetadata_manager = new DepositorMetadataManager();
 	translation_manager = new TranslationView();
     if (Gatherer.GS3) {
@@ -160,4 +163,6 @@
 	supercollection_manager.destroy();
 	supercollection_manager = null;
+	depositormetadata_manager.destroy();
+	depositormetadata_manager = null;
 	translation_manager.destroy();
 	translation_manager = null;
@@ -178,4 +183,5 @@
 	language_manager.modeChanged(mode);
 	searchmetadata_manager.modeChanged(mode);
+	depositormetadata_manager.modeChanged(mode);
     }
 
